/*
 * FAB 3226 application program
 */
#include <iostream>	
#include <unistd.h>
#include "rio/rio.hxx"


const char *szDevice = "/dev/irio/0";
const char *szConfig = "../../../quartus/fab/basic/fab_basic.rbf";

namespace Rio=INdepRio100;

  int main(int argc, char **argv) {
    int chOpt;


    while ((chOpt=getopt(argc, argv, "")) != EOF) {
      if (chOpt == '?' ) {
	std::cerr << "usage: " << argv[0] << " [config .rbf file]" << std::endl;
	return 2;
      }
    }

    if (argc == 2) szConfig=argv[1];

    /*
     * Initialize Rio Interface
     */
    Rio::RioLocalTaskInitializer ri(szDevice);
    if (!ri) {
      std::cout << ri << std::endl;
      return 2; 
    }

    Rio::RioTaskPlex * const prp=ri.prp();	/* convenience notation */


    /* 
     * configure FPFA fabric
     */
    if (!prp->callRioInitFile(szConfig)) {
      std::cerr << "config failed " << *prp << std::endl;
      return 2;
    }
    std::cout << "FPGA now configured: " << prp->sgConfig() << std::endl;
    std::cout << "press Enter to quit" << std::endl;

    /* wait for key pressed */
    std::cin.peek();

    /*
     * FPGA is unconfigured before returning 
     */
    return 0;
  }






