/* fiora { */
  iwDin, owDout, owDoen,

  /* FX2 56pin GPIF lines */
  ifCLK, iowFD, owRdy, iwCtl, owIntn, iwPA,
  obWakeupn, owLED
);

  input [15:0] iwDin;	/* inputs               */
  output [15:0] owDout, owDoen;

  input ifCLK;		/* 30 Mhz from FX	*/
  inout [15:0] iowFD;	/* data IO, fxdef=I	*/
  output [1:0] owRdy;	/* ready, fxdef=I	*/
  input [2:0] iwCtl;	/* control, fxdef=H	*/
  output[1:0] owLED;

  /* Port A */
  output [1:0] owIntn;	/* intr, fxdef=I	*/
  input [7:3] iwPA;	/* PORT A, fxdef=I	*/

  output obWakeupn;	/* fxdef=I		*/



  wire[4:0] wwAddr;	/* internal addr bus	*/
  wire wbRdp;		/* read pulse, 		*/
  wire wbWrp;		/* write pulse		*/
  wire [15:0] wwRdData;	/* CPU read data	*/
  wire [15:0] wwWrData;  /* CPU write data	*/
  wire wbDmaIn;		/* core dma in enable	*/
  wire wbDmaOut;	/* core dma out enable  */
  wire wbIntr;
  wire wbFwFulln;
  wire wbFwEmptyn;
  wire wbFrFulln;
  wire wbFrEmptyn;

  wire clock=ifCLK;
  wire reset=1'b0;

  assign #1 owIntn[0] = ~wbIntr;
  assign #1 owIntn[1] = ~(owRdy[0] || owRdy[1]); 
  assign #1 obWakeupn = 1'b1;


  /* FX IO */
  assign #1 owRdy[1] = (wbDmaIn && wbFwFulln);
  assign #1 owRdy[0] = (wbDmaOut && wbFrEmptyn);
  assign #1 wwAddr[4:0] = iwPA[7:3];
  assign #1 wbRdp = iwCtl[0];
  assign #1 wbWrp = iwCtl[1];
  assign #1 iowFD[15:0] = ( !wbWrp ) ? wwRdData : 16'hzz ;
  assign #1 wwWrData[15:0] = iowFD[15:0];
  /* } fiora  */
