#ifndef _CPLRAW_SM_HXX
#define _CPLRAW_SM_HXX 1

/*
 *	sm.hxx
 *	ines foundation state machine class
 *
 *	970827	ws	created
 */



/**
 *	minimal state machine
 */
class SmM {
	int _e;			/* current state	*/
public:
	int eState() const { return _e; }
	bool isState(int e) { return _e==e; }
	bool isState(int e1, int e2) { return (_e==e1 || _e == e2); }
	int setState(int e) { return _e=e; }	/**< returns new state */

	/** 
	 * set new state
	 * \return previous state 
	 */
	int eStatePrev( int e ) {	
		int ePrev=_e;
		_e=e;
		return ePrev;
	}

	/**
	 * unconditionally set state to eNew,
	 * \return true if old state was ePrev
	 */
	int wasState(int eNew, int ePrev);

	/**
	 * increment state only if current state is eTest
	 * \return true if old state was eTest 
	 */
	int changeState(int eNew, int eTest);
	int incState(int eTest) { return changeState(eTest+1, eTest); }

	SmM(int e=0);	
	~SmM();
};



#endif 
