/*
 * This file is automatically created
 * DO NOT EDIT
 */
#include "cplRaw/wire.hxx"
#include "umic/umi.hxx"
#ifndef _UMIPRO_DINO_HXX_
#define _UMIPRO_DINO_HXX_
typedef INdepUmi100::Time UmiTime;
namespace INdepDino100 {

  using namespace INdepUmi100;


  /*
   * class DinoResp - status response
   */

  class DinoResp:public UmiControl  {
    unsigned _eErr;	/* result (error) code	*/
    unsigned _iErr;	/* result (error) code, detailed	*/
   public:
     friend xistream& xunmarsh(xistream &xi, DinoResp&);
     friend xostream& xmarshal(xostream &xo, const DinoResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const DinoResp&);
    #endif
    unsigned eErr() const { return _eErr; }
    DinoResp& eErr(unsigned __eErr) { _eErr=__eErr ; return *this; }
    unsigned iErr() const { return _iErr; }
    DinoResp& iErr(unsigned __iErr) { _iErr=__iErr ; return *this; }

    DinoResp(int e=0x4, size_t s=0);
    ~DinoResp() {}
  };


  /*
   * class DinoOpenResp - open response
   */

  class DinoOpenResp:public DinoResp  {
    unsigned _fBit;	/* bit mask	*/
    unsigned _iByte;	/* byte index	*/
   public:
     friend xistream& xunmarsh(xistream &xi, DinoOpenResp&);
     friend xostream& xmarshal(xostream &xo, const DinoOpenResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const DinoOpenResp&);
    #endif
    unsigned fBit() const { return _fBit; }
    DinoOpenResp& fBit(unsigned __fBit) { _fBit=__fBit ; return *this; }
    unsigned iByte() const { return _iByte; }
    DinoOpenResp& iByte(unsigned __iByte) { _iByte=__iByte ; return *this; }

    DinoOpenResp(int e=0x5, size_t s=0);
    ~DinoOpenResp() {}
  };


  /*
   * class DinoOpen - open ports
   */

  class DinoOpen:public UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, DinoOpen&);
     friend xostream& xmarshal(xostream &xo, const DinoOpen&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const DinoOpen&);
    #endif

    DinoOpen(int e=0x6, size_t s=0);
    ~DinoOpen() {}
  };


  /*
   * class DinoSync - sync 
   */

  class DinoSync:public UmiControl  {
    UmiTime _tiTmo;
   public:
     friend xistream& xunmarsh(xistream &xi, DinoSync&);
     friend xostream& xmarshal(xostream &xo, const DinoSync&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const DinoSync&);
    #endif
    const UmiTime& tiTmo() const { return _tiTmo; }
    void tiTmo( const UmiTime& __tiTmo) {_tiTmo=__tiTmo ; }

    DinoSync(int e=0x7, size_t s=0);
    ~DinoSync() {}
  };

  inline bool isDinoResp(const UmiControl *puc) { return ( puc->eType() == 0x4 ); }
  extern DinoResp* pDinoResp(UmiControl *);
  inline const DinoResp* pDinoResp(const UmiControl *puc) { return pDinoResp(const_cast<UmiControl*>(puc)); }
  inline bool isDinoOpenResp(const UmiControl *puc) { return ( puc->eType() == 0x5 ); }
  extern DinoOpenResp* pDinoOpenResp(UmiControl *);
  inline const DinoOpenResp* pDinoOpenResp(const UmiControl *puc) { return pDinoOpenResp(const_cast<UmiControl*>(puc)); }
  inline bool isDinoOpen(const UmiControl *puc) { return ( puc->eType() == 0x6 ); }
  extern DinoOpen* pDinoOpen(UmiControl *);
  inline const DinoOpen* pDinoOpen(const UmiControl *puc) { return pDinoOpen(const_cast<UmiControl*>(puc)); }
  inline bool isDinoSync(const UmiControl *puc) { return ( puc->eType() == 0x7 ); }
  extern DinoSync* pDinoSync(UmiControl *);
  inline const DinoSync* pDinoSync(const UmiControl *puc) { return pDinoSync(const_cast<UmiControl*>(puc)); }

  #define MSG_DinoResp 0x4
  #define MSG_DinoOpenResp 0x5
  #define MSG_DinoOpen 0x6
  #define MSG_DinoSync 0x7

  class Dino_dino_Proto:public UmiProto {
   public:
    xistream& unmarsh(xistream &, const UmiControl &, UmiControl *) const;
    xostream& marshal(xostream &, const UmiControl *) const ;
    Dino_dino_Proto();
    ~Dino_dino_Proto();
  };

  #define PROTID_dino "(/Int4:unsigned,Int4:unsigned/)((/Int4:unsigned,Int4:unsigned/)/Int1:unsigned,Int2:unsigned/)(//)(//(/Int4:u_int,Int4:u_int/))"
  /* Services */
}
#endif
