#ifndef _DINO_DAP_HXX
#define _DINO_DAP_HXX

/**
 * \file 
 * Dino Application Elements
 */

#include "umi/uc_d.hxx"
#include "dim.hxx"
#include "dino/dino.hxx"

namespace INdepDev100 {
  namespace Umi=INdepUmi100;


  /**
   * process-local application initializer
   */
  class DioLocalInitializer:public Failables {
    DioMux *_ptm;		/* device controller	*/
    Umi::ChanDevio *_puc;	/* device i/o channel */
    Umi::LocalChannelPair _lcDino;



   protected:
    void init(Umi::ChanDevio* puc);

   public:
    void initDinoUser(const std::string &sgPort, Dino::DinoPlex *pdp);

    /**
     * \return TinaPlex available after successfull initialization, 0 otherwise
     */
    Umi::ChanDevio *puc() { return _puc; }


    /**
     * configure all resources necessary for process-local operation
     *
     * On return check via isGood() for successful initialization.
     */
    DioLocalInitializer(const char *szDevice);
    DioLocalInitializer(Umi::ChanDevio *puc);

    ~DioLocalInitializer();
  };

}

#endif




