#ifndef _RIO_SIO_HXX_
#define _RIO_SIO_HXX_

/*
 * 
 */
#include <sstream>	
#include "umi/uc_d.hxx"
#include "umi/umi_task.hxx"
#include "rioc/umipro_sio.hxx"
#include "aes/aes.hxx"


namespace INdepSio100 {	
  namespace Umi=INdepUmi100 ;
  namespace Aes=INdepAes100 ;

  extern const Sio_sio_Proto theSio_sio_Proto ;

  class SioSyncFunc:public Umi::TaskFunc::Func {
    int _cnSio;
    int _f;

    int cnSio() const { return _cnSio; }

   public:
    int f() const { return _f; }
    int func( int eState );
    SioSyncFunc(int cnSio, int f):_cnSio(cnSio), _f(f) {  }
    ~SioSyncFunc() { }
  };

  class SioReadFunc:public Umi::TaskFunc::Func {
    int _cnSio;
    int _iPort;
    int _iVal;

    int cnSio() const { return _cnSio; }

   public:
    int iVal() const { return _iVal; }
    int func( int eState );
    SioReadFunc(int cnSio, int iPort):_cnSio(cnSio), _iPort(iPort), _iVal(0) {  }
    ~SioReadFunc() { }
  };

  class SioWriteFunc:public Umi::TaskFunc::Func {
    int _cnSio;
    int _iPort, _iVal;

    int cnSio() const { return _cnSio; }

   public:
    int func( int eState );
    SioWriteFunc(int cnSio, int iPort, int iVal ):_cnSio(cnSio), _iPort(iPort), _iVal(iVal) { }
    ~SioWriteFunc() { }
  };

  class SioTaskPlex:public Aes::AesTaskPlex {


   public:

    int callSioSync(int f) { 
      SioSyncFunc *ptf;
      run(ptf=new SioSyncFunc(0, f));
      return 0;
    }

    int callSioRead(int iPort) { 
      SioReadFunc *ptf;
      run(ptf=new SioReadFunc(0, iPort));
      return ptf->iVal();
    }

    void callSioWrite(int iPort, int iVal) { 
      run(new SioWriteFunc(0, iPort, iVal));
    }

    SioTaskPlex(Umi::Channel *puc, Umi::ChanUser *pucIo):Aes::AesTaskPlex(puc, pucIo) {
      assert(*(pucIo->pup()) == theSio_sio_Proto); 
      assert(*(puc->pup()) == theSio_sio_Proto); 
    }
    ~SioTaskPlex() { }
  };

  class SioLocalTaskInitializer:public Failables {
    Umi::ChanDevio *_puc;	/* szDevice i/o channel */
    SioTaskPlex *_psp;		/* endpoint plexer */
   public:
    SioTaskPlex *psp() const { return _psp; }

    /**
     * configure all resources necessary for process-local operation
     *
     * \arg szDevice system specific path to device node, e.g. "/dev/itina/0"
     *
     * On return check via isGood() for successful initialization.
     */
    SioLocalTaskInitializer(const char *szDevice);	/* open only */
    ~SioLocalTaskInitializer();
  };

}



#endif
