/*
 * This file is automatically created
 * DO NOT EDIT
 */
#include "rioc/wire_rio.hxx"
#include "aesc/umipro_aes.hxx"
#include "umic/umi.hxx"
#ifndef _UMIPRO_RIO_HXX_
#define _UMIPRO_RIO_HXX_
typedef INdepUmi100::Time UmiTime;
namespace INdepRio100 {

  using namespace INdepUmi100;


  /*
   * class RioInfo - Interface information
   */

  class RioInfo {
    u_int _eArch;	/* interface architecture id	*/
    u_int _cIntr;	/* hardware interrupt counter	*/
    u_int _fLinec;	/* line sense capability	*/
   public:
     friend xistream& xunmarsh(xistream &xi, RioInfo&);
     friend xostream& xmarshal(xostream &xo, const RioInfo&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const RioInfo&);
    #endif
    u_int eArch() const { return _eArch; }
    RioInfo& eArch(u_int __eArch) { _eArch=__eArch ; return *this; }
    u_int cIntr() const { return _cIntr; }
    RioInfo& cIntr(u_int __cIntr) { _cIntr=__cIntr ; return *this; }
    u_int fLinec() const { return _fLinec; }
    RioInfo& fLinec(u_int __fLinec) { _fLinec=__fLinec ; return *this; }

    RioInfo():_eArch(0),_cIntr(0),_fLinec(0) { }
    RioInfo(u_int eArch,u_int cIntr,u_int fLinec):_eArch(eArch),_cIntr(cIntr),_fLinec(fLinec) { }
    ~RioInfo() {}
  };


  /*
   * class RioRead - register read
   */

  class RioRead:public UmiControl  {
    u_int _iPort;	/* register number	*/
   public:
     friend xistream& xunmarsh(xistream &xi, RioRead&);
     friend xostream& xmarshal(xostream &xo, const RioRead&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const RioRead&);
    #endif
    u_int iPort() const { return _iPort; }
    RioRead& iPort(u_int __iPort) { _iPort=__iPort ; return *this; }

    RioRead(int e=0x7, size_t s=0);
    ~RioRead() {}
  };


  /*
   * class RioWrite - register write
   */

  class RioWrite:public RioRead  {
    u_int _iVal;	/* register value	*/
   public:
     friend xistream& xunmarsh(xistream &xi, RioWrite&);
     friend xostream& xmarshal(xostream &xo, const RioWrite&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const RioWrite&);
    #endif
    u_int iVal() const { return _iVal; }
    RioWrite& iVal(u_int __iVal) { _iVal=__iVal ; return *this; }

    RioWrite(int e=0x8, size_t s=0);
    ~RioWrite() {}
  };


  /*
   * class RioTrf - common transfer parameters
   */

  class RioTrf:public UmiControl  {
    UmiTime _tiTmo;
    u_int _iTrans;	/* transaction id	*/
    u_int _fLast;	/* last of transaction	*/
   public:
     friend xistream& xunmarsh(xistream &xi, RioTrf&);
     friend xostream& xmarshal(xostream &xo, const RioTrf&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const RioTrf&);
    #endif
    const UmiTime& tiTmo() const { return _tiTmo; }
    void tiTmo( const UmiTime& __tiTmo) {_tiTmo=__tiTmo ; }
    u_int iTrans() const { return _iTrans; }
    RioTrf& iTrans(u_int __iTrans) { _iTrans=__iTrans ; return *this; }
    bool fLast() const { return _fLast!= 0 ; }
    RioTrf& fLast(bool __fLast) { _fLast=__fLast ; return *this; }

    RioTrf(int e=0x9, size_t s=0);
    ~RioTrf() {}
  };


  /*
   * class RioFini - Interface shutdown
   */

  class RioFini:public UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, RioFini&);
     friend xostream& xmarshal(xostream &xo, const RioFini&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const RioFini&);
    #endif

    RioFini(int e=0xa, size_t s=0);
    ~RioFini() {}
  };


  /*
   * class RioCmd - send commands request
   */

  class RioCmd:public RioTrf  {
   public:
     friend xistream& xunmarsh(xistream &xi, RioCmd&);
     friend xostream& xmarshal(xostream &xo, const RioCmd&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const RioCmd&);
    #endif

    RioCmd(int e=0xb, size_t s=0);
    ~RioCmd() {}
  };


  /*
   * class RioResp - status response
   */

  class RioResp:public UmiControl  {
    u_int _eErr;	/* result (error) code	*/
    u_int _iErr;	/* result (error) code, detailed	*/
    u_int _fStat;	/* status flags (StatE)	*/
   public:
     friend xistream& xunmarsh(xistream &xi, RioResp&);
     friend xostream& xmarshal(xostream &xo, const RioResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const RioResp&);
    #endif
    u_int eErr() const { return _eErr; }
    RioResp& eErr(u_int __eErr) { _eErr=__eErr ; return *this; }
    u_int iErr() const { return _iErr; }
    RioResp& iErr(u_int __iErr) { _iErr=__iErr ; return *this; }
    u_int fStat() const { return _fStat; }
    RioResp& fStat(u_int __fStat) { _fStat=__fStat ; return *this; }

    RioResp(int e=0xc, size_t s=0);
    ~RioResp() {}
  };


  /*
   * class RioWrResp - write response
   */

  class RioWrResp:public RioResp  {
    u_int _cTrans;	/* bytes transmitted	*/
   public:
     friend xistream& xunmarsh(xistream &xi, RioWrResp&);
     friend xostream& xmarshal(xostream &xo, const RioWrResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const RioWrResp&);
    #endif
    u_int cTrans() const { return _cTrans; }
    RioWrResp& cTrans(u_int __cTrans) { _cTrans=__cTrans ; return *this; }

    RioWrResp(int e=0xd, size_t s=0);
    ~RioWrResp() {}
  };


  /*
   * class RioInfoResp - info response
   */

  class RioInfoResp:public RioResp  {
    RioInfo _info;
   public:
     friend xistream& xunmarsh(xistream &xi, RioInfoResp&);
     friend xostream& xmarshal(xostream &xo, const RioInfoResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const RioInfoResp&);
    #endif
    const RioInfo& info() const { return _info; }
    void info( const RioInfo& __info) {_info=__info ; }

    RioInfoResp(int e=0xe, size_t s=0);
    ~RioInfoResp() {}
  };

  inline bool isRioRead(const UmiControl *puc) { return ( puc->eType() == 0x7 ); }
  extern RioRead* pRioRead(UmiControl *);
  inline const RioRead* pRioRead(const UmiControl *puc) { return pRioRead(const_cast<UmiControl*>(puc)); }
  inline bool isRioWrite(const UmiControl *puc) { return ( puc->eType() == 0x8 ); }
  extern RioWrite* pRioWrite(UmiControl *);
  inline const RioWrite* pRioWrite(const UmiControl *puc) { return pRioWrite(const_cast<UmiControl*>(puc)); }
  inline bool isRioTrf(const UmiControl *puc) { return ( puc->eType() == 0x9 ); }
  extern RioTrf* pRioTrf(UmiControl *);
  inline const RioTrf* pRioTrf(const UmiControl *puc) { return pRioTrf(const_cast<UmiControl*>(puc)); }
  inline bool isRioFini(const UmiControl *puc) { return ( puc->eType() == 0xa ); }
  extern RioFini* pRioFini(UmiControl *);
  inline const RioFini* pRioFini(const UmiControl *puc) { return pRioFini(const_cast<UmiControl*>(puc)); }
  inline bool isRioCmd(const UmiControl *puc) { return ( puc->eType() == 0xb ); }
  extern RioCmd* pRioCmd(UmiControl *);
  inline const RioCmd* pRioCmd(const UmiControl *puc) { return pRioCmd(const_cast<UmiControl*>(puc)); }
  inline bool isRioResp(const UmiControl *puc) { return ( puc->eType() == 0xc ); }
  extern RioResp* pRioResp(UmiControl *);
  inline const RioResp* pRioResp(const UmiControl *puc) { return pRioResp(const_cast<UmiControl*>(puc)); }
  inline bool isRioWrResp(const UmiControl *puc) { return ( puc->eType() == 0xd ); }
  extern RioWrResp* pRioWrResp(UmiControl *);
  inline const RioWrResp* pRioWrResp(const UmiControl *puc) { return pRioWrResp(const_cast<UmiControl*>(puc)); }
  inline bool isRioInfoResp(const UmiControl *puc) { return ( puc->eType() == 0xe ); }
  extern RioInfoResp* pRioInfoResp(UmiControl *);
  inline const RioInfoResp* pRioInfoResp(const UmiControl *puc) { return pRioInfoResp(const_cast<UmiControl*>(puc)); }

  #define MSG_RioRead 0x7
  #define MSG_RioWrite 0x8
  #define MSG_RioTrf 0x9
  #define MSG_RioFini 0xa
  #define MSG_RioCmd 0xb
  #define MSG_RioResp 0xc
  #define MSG_RioWrResp 0xd
  #define MSG_RioInfoResp 0xe

  class Rio_rio_Proto:public UmiProto {
   public:
    xistream& unmarsh(xistream &, const UmiControl &, UmiControl *) const;
    xostream& marshal(xostream &, const UmiControl *) const ;
    Rio_rio_Proto();
    ~Rio_rio_Proto();
  };

  #define PROTID_rio "(//)(//)(/Int4:u_int,Int4:u_int,Int4:u_int/)(//)(/Int4:u_int,Int4:u_int,Int4:u_int/)((/Int4:u_int,Int4:u_int,Int4:u_int/)/Int4:u_int/)(/Int1:u_int,Int4:u_int,Int4:u_int/)((/Int4:u_int,Int4:u_int,Int4:u_int/)//(/Int1:u_int,Int4:u_int,Int4:u_int/))(/Int1:u_int/)((/Int1:u_int/)/Int2:u_int/)(/Int4:u_int,Int1:bool/(/Int4:u_int,Int4:u_int/))((/Int4:u_int,Int1:bool/(/Int4:u_int,Int4:u_int/))//)"
}
#endif
