/*
 * This file is automatically created
 * DO NOT EDIT
 */
#include "rioc/wire_sio.hxx"
#include "aesc/umipro_aes.hxx"
#include "umic/umi.hxx"
#ifndef _UMIPRO_SIO_HXX_
#define _UMIPRO_SIO_HXX_
typedef INdepUmi100::Time UmiTime;
namespace INdepSio100 {

  using namespace INdepUmi100;


  /*
   * class SioSync - sync
   */

  class SioSync:public UmiControl  {
    u_int _fCtrl;	/* control word	*/
   public:
     friend xistream& xunmarsh(xistream &xi, SioSync&);
     friend xostream& xmarshal(xostream &xo, const SioSync&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const SioSync&);
    #endif
    u_int fCtrl() const { return _fCtrl; }
    SioSync& fCtrl(u_int __fCtrl) { _fCtrl=__fCtrl ; return *this; }

    SioSync(int e=0x7, size_t s=0);
    ~SioSync() {}
  };


  /*
   * class SioRead - register read
   */

  class SioRead:public UmiControl  {
    u_int _iPort;	/* register number	*/
   public:
     friend xistream& xunmarsh(xistream &xi, SioRead&);
     friend xostream& xmarshal(xostream &xo, const SioRead&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const SioRead&);
    #endif
    u_int iPort() const { return _iPort; }
    SioRead& iPort(u_int __iPort) { _iPort=__iPort ; return *this; }

    SioRead(int e=0x8, size_t s=0);
    ~SioRead() {}
  };


  /*
   * class SioWrite - register write
   */

  class SioWrite:public SioRead  {
    u_int _iVal;	/* register value	*/
   public:
     friend xistream& xunmarsh(xistream &xi, SioWrite&);
     friend xostream& xmarshal(xostream &xo, const SioWrite&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const SioWrite&);
    #endif
    u_int iVal() const { return _iVal; }
    SioWrite& iVal(u_int __iVal) { _iVal=__iVal ; return *this; }

    SioWrite(int e=0x9, size_t s=0);
    ~SioWrite() {}
  };


  /*
   * class SioResp - status response
   */

  class SioResp:public UmiControl  {
    u_int _eErr;	/* result (error) code	*/
    u_int _fStat;	/* input status word	*/
   public:
     friend xistream& xunmarsh(xistream &xi, SioResp&);
     friend xostream& xmarshal(xostream &xo, const SioResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const SioResp&);
    #endif
    u_int eErr() const { return _eErr; }
    SioResp& eErr(u_int __eErr) { _eErr=__eErr ; return *this; }
    u_int fStat() const { return _fStat; }
    SioResp& fStat(u_int __fStat) { _fStat=__fStat ; return *this; }

    SioResp(int e=0xa, size_t s=0);
    ~SioResp() {}
  };

  inline bool isSioSync(const UmiControl *puc) { return ( puc->eType() == 0x7 ); }
  extern SioSync* pSioSync(UmiControl *);
  inline const SioSync* pSioSync(const UmiControl *puc) { return pSioSync(const_cast<UmiControl*>(puc)); }
  inline bool isSioRead(const UmiControl *puc) { return ( puc->eType() == 0x8 ); }
  extern SioRead* pSioRead(UmiControl *);
  inline const SioRead* pSioRead(const UmiControl *puc) { return pSioRead(const_cast<UmiControl*>(puc)); }
  inline bool isSioWrite(const UmiControl *puc) { return ( puc->eType() == 0x9 ); }
  extern SioWrite* pSioWrite(UmiControl *);
  inline const SioWrite* pSioWrite(const UmiControl *puc) { return pSioWrite(const_cast<UmiControl*>(puc)); }
  inline bool isSioResp(const UmiControl *puc) { return ( puc->eType() == 0xa ); }
  extern SioResp* pSioResp(UmiControl *);
  inline const SioResp* pSioResp(const UmiControl *puc) { return pSioResp(const_cast<UmiControl*>(puc)); }

  #define MSG_SioSync 0x7
  #define MSG_SioRead 0x8
  #define MSG_SioWrite 0x9
  #define MSG_SioResp 0xa

  class Sio_sio_Proto:public UmiProto {
   public:
    xistream& unmarsh(xistream &, const UmiControl &, UmiControl *) const;
    xostream& marshal(xostream &, const UmiControl *) const ;
    Sio_sio_Proto();
    ~Sio_sio_Proto();
  };

  #define PROTID_sio "(//)(//)(/Int4:u_int,Int4:u_int,Int4:u_int/)(/Int1:u_int/)(/Int1:u_int/)((/Int1:u_int/)/Int2:u_int/)(/Int4:u_int,Int4:u_int/)"
}
#endif
