/*
 * This file is automatically created
 * DO NOT EDIT
 */
#include "cplRaw/wire.hxx"
#include "umic/umi.hxx"
#ifndef _UMIPRO_PULI_HXX_
#define _UMIPRO_PULI_HXX_
typedef INdepUmi100::Time UmiTime;
namespace INdepPuli100 {

  using namespace INdepUmi100;


  /*
   * class PuliPulseConfig - configure pulse generator
   */

  class PuliPulseConfig:public UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, PuliPulseConfig&);
     friend xostream& xmarshal(xostream &xo, const PuliPulseConfig&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const PuliPulseConfig&);
    #endif

    PuliPulseConfig(int e=0x4, size_t s=0);
    ~PuliPulseConfig() {}
  };


  /*
   * class PuliSetTimer - set Timer
   */

  class PuliSetTimer:public UmiControl  {
    UmiTime _ti;
   public:
     friend xistream& xunmarsh(xistream &xi, PuliSetTimer&);
     friend xostream& xmarshal(xostream &xo, const PuliSetTimer&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const PuliSetTimer&);
    #endif
    const UmiTime& ti() const { return _ti; }
    void ti( const UmiTime& __ti) {_ti=__ti ; }

    PuliSetTimer(int e=0x5, size_t s=0);
    ~PuliSetTimer() {}
  };


  /*
   * class PuliInit - init
   */

  class PuliInit:public UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, PuliInit&);
     friend xostream& xmarshal(xostream &xo, const PuliInit&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const PuliInit&);
    #endif

    PuliInit(int e=0x6, size_t s=0);
    ~PuliInit() {}
  };


  /*
   * class PuliConfig - configure sampling
   */

  class PuliConfig:public UmiControl  {
    unsigned _cScale;	/* prescaler setup	*/
   public:
     friend xistream& xunmarsh(xistream &xi, PuliConfig&);
     friend xostream& xmarshal(xostream &xo, const PuliConfig&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const PuliConfig&);
    #endif
    unsigned cScale() const { return _cScale; }
    PuliConfig& cScale(unsigned __cScale) { _cScale=__cScale ; return *this; }

    PuliConfig(int e=0x7, size_t s=0);
    ~PuliConfig() {}
  };


  /*
   * class PuliSample - start sampling
   */

  class PuliSample:public UmiControl  {
    UmiTime _tiTmo;
   public:
     friend xistream& xunmarsh(xistream &xi, PuliSample&);
     friend xostream& xmarshal(xostream &xo, const PuliSample&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const PuliSample&);
    #endif
    const UmiTime& tiTmo() const { return _tiTmo; }
    void tiTmo( const UmiTime& __tiTmo) {_tiTmo=__tiTmo ; }

    PuliSample(int e=0x8, size_t s=0);
    ~PuliSample() {}
  };


  /*
   * class PuliStop - stop sampling
   */

  class PuliStop:public UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, PuliStop&);
     friend xostream& xmarshal(xostream &xo, const PuliStop&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const PuliStop&);
    #endif

    PuliStop(int e=0x9, size_t s=0);
    ~PuliStop() {}
  };


  /*
   * class PuliResp - status response
   */

  class PuliResp:public UmiControl  {
    unsigned _eErr;	/* result (error) code	*/
    unsigned _iErr;	/* result (error) code, detailed	*/
   public:
     friend xistream& xunmarsh(xistream &xi, PuliResp&);
     friend xostream& xmarshal(xostream &xo, const PuliResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const PuliResp&);
    #endif
    unsigned eErr() const { return _eErr; }
    PuliResp& eErr(unsigned __eErr) { _eErr=__eErr ; return *this; }
    unsigned iErr() const { return _iErr; }
    PuliResp& iErr(unsigned __iErr) { _iErr=__iErr ; return *this; }

    PuliResp(int e=0xa, size_t s=0);
    ~PuliResp() {}
  };

  inline bool isPuliPulseConfig(const UmiControl *puc) { return ( puc->eType() == 0x4 ); }
  extern PuliPulseConfig* pPuliPulseConfig(UmiControl *);
  inline const PuliPulseConfig* pPuliPulseConfig(const UmiControl *puc) { return pPuliPulseConfig(const_cast<UmiControl*>(puc)); }
  inline bool isPuliSetTimer(const UmiControl *puc) { return ( puc->eType() == 0x5 ); }
  extern PuliSetTimer* pPuliSetTimer(UmiControl *);
  inline const PuliSetTimer* pPuliSetTimer(const UmiControl *puc) { return pPuliSetTimer(const_cast<UmiControl*>(puc)); }
  inline bool isPuliInit(const UmiControl *puc) { return ( puc->eType() == 0x6 ); }
  extern PuliInit* pPuliInit(UmiControl *);
  inline const PuliInit* pPuliInit(const UmiControl *puc) { return pPuliInit(const_cast<UmiControl*>(puc)); }
  inline bool isPuliConfig(const UmiControl *puc) { return ( puc->eType() == 0x7 ); }
  extern PuliConfig* pPuliConfig(UmiControl *);
  inline const PuliConfig* pPuliConfig(const UmiControl *puc) { return pPuliConfig(const_cast<UmiControl*>(puc)); }
  inline bool isPuliSample(const UmiControl *puc) { return ( puc->eType() == 0x8 ); }
  extern PuliSample* pPuliSample(UmiControl *);
  inline const PuliSample* pPuliSample(const UmiControl *puc) { return pPuliSample(const_cast<UmiControl*>(puc)); }
  inline bool isPuliStop(const UmiControl *puc) { return ( puc->eType() == 0x9 ); }
  extern PuliStop* pPuliStop(UmiControl *);
  inline const PuliStop* pPuliStop(const UmiControl *puc) { return pPuliStop(const_cast<UmiControl*>(puc)); }
  inline bool isPuliResp(const UmiControl *puc) { return ( puc->eType() == 0xa ); }
  extern PuliResp* pPuliResp(UmiControl *);
  inline const PuliResp* pPuliResp(const UmiControl *puc) { return pPuliResp(const_cast<UmiControl*>(puc)); }

  #define MSG_PuliPulseConfig 0x4
  #define MSG_PuliSetTimer 0x5
  #define MSG_PuliInit 0x6
  #define MSG_PuliConfig 0x7
  #define MSG_PuliSample 0x8
  #define MSG_PuliStop 0x9
  #define MSG_PuliResp 0xa

  class Puli_puli_Proto:public UmiProto {
   public:
    xistream& unmarsh(xistream &, const UmiControl &, UmiControl *) const;
    xostream& marshal(xostream &, const UmiControl *) const ;
    Puli_puli_Proto();
    ~Puli_puli_Proto();
  };

  #define PROTID_puli "(/Int4:unsigned,Int4:unsigned/)(//(/Int4:u_int,Int4:u_int/))(//)(//(/Int4:u_int,Int4:u_int/))(//)(/Int4:unsigned/)(//)"
  /* Services */
  /* SetTimer */
  class Puli_puli_Service_SetTimer:public UmiService {
    PuliSetTimer _rq;
    PuliResp _rp;
  };
  /* Init */
  class Puli_puli_Service_Init:public UmiService {
    PuliInit _rq;
    PuliResp _rp;
  };
}
#endif
