/*
 * This file is automatically created
 * DO NOT EDIT
 */
#include "cplRaw/wire.hxx"
#include "umic/umi.hxx"
#ifndef _UMIPRO_TINA_HXX_
#define _UMIPRO_TINA_HXX_
typedef INdepUmi100::Time UmiTime;
namespace INdepTina100 {

  using namespace INdepUmi100;


  /*
   * class TinaPulseConfig - configure pulse generator
   */

  class TinaPulseConfig:public UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, TinaPulseConfig&);
     friend xostream& xmarshal(xostream &xo, const TinaPulseConfig&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const TinaPulseConfig&);
    #endif

    TinaPulseConfig(int e=0x4, size_t s=0);
    ~TinaPulseConfig() {}
  };


  /*
   * class TinaSetTimer - set Timer
   */

  class TinaSetTimer:public UmiControl  {
    UmiTime _ti;
   public:
     friend xistream& xunmarsh(xistream &xi, TinaSetTimer&);
     friend xostream& xmarshal(xostream &xo, const TinaSetTimer&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const TinaSetTimer&);
    #endif
    const UmiTime& ti() const { return _ti; }
    void ti( const UmiTime& __ti) {_ti=__ti ; }

    TinaSetTimer(int e=0x5, size_t s=0);
    ~TinaSetTimer() {}
  };


  /*
   * class TinaInit - init
   */

  class TinaInit:public UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, TinaInit&);
     friend xostream& xmarshal(xostream &xo, const TinaInit&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const TinaInit&);
    #endif

    TinaInit(int e=0x6, size_t s=0);
    ~TinaInit() {}
  };


  /*
   * class TinaConfig - configure sampling
   */

  class TinaConfig:public UmiControl  {
    unsigned _cScale;	/* prescaler setup	*/
    unsigned _mpfIgnFirst[2];	/* ignore first sample	*/
    unsigned _mpcLimit[2];	/* sample count limit	*/
    unsigned _mpeFilt[2];	/* input filter selector	*/
    unsigned _mpeEdge[2];	/* edge selector [r/f]	*/
    unsigned _mpeFil[2];	/* input filter selector	*/
    unsigned _mpeEna[2];	/* input enable selector	*/
    unsigned _mpeArm[2];	/* arm selector	*/
    unsigned _mpeExc[2];	/* external capture selector	*/
    unsigned _mpeFiExc[2];	/* external capture filter	*/
    unsigned _mpeFiArm[2];	/* external arm filter	*/
    unsigned _mpeFiEna[2];	/* external enable filter	*/
   public:
     friend xistream& xunmarsh(xistream &xi, TinaConfig&);
     friend xostream& xmarshal(xostream &xo, const TinaConfig&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const TinaConfig&);
    #endif
    unsigned cScale() const { return _cScale; }
    TinaConfig& cScale(unsigned __cScale) { _cScale=__cScale ; return *this; }
    unsigned fIgnFirst(int i) const { return _mpfIgnFirst[i]; }
    void fIgnFirst( int i, unsigned __fIgnFirst) { _mpfIgnFirst[i]=__fIgnFirst ; }
    unsigned cLimit(int i) const { return _mpcLimit[i]; }
    void cLimit( int i, unsigned __cLimit) { _mpcLimit[i]=__cLimit ; }
    unsigned eFilt(int i) const { return _mpeFilt[i]; }
    void eFilt( int i, unsigned __eFilt) { _mpeFilt[i]=__eFilt ; }
    unsigned eEdge(int i) const { return _mpeEdge[i]; }
    void eEdge( int i, unsigned __eEdge) { _mpeEdge[i]=__eEdge ; }
    unsigned eFil(int i) const { return _mpeFil[i]; }
    void eFil( int i, unsigned __eFil) { _mpeFil[i]=__eFil ; }
    unsigned eEna(int i) const { return _mpeEna[i]; }
    void eEna( int i, unsigned __eEna) { _mpeEna[i]=__eEna ; }
    unsigned eArm(int i) const { return _mpeArm[i]; }
    void eArm( int i, unsigned __eArm) { _mpeArm[i]=__eArm ; }
    unsigned eExc(int i) const { return _mpeExc[i]; }
    void eExc( int i, unsigned __eExc) { _mpeExc[i]=__eExc ; }
    unsigned eFiExc(int i) const { return _mpeFiExc[i]; }
    void eFiExc( int i, unsigned __eFiExc) { _mpeFiExc[i]=__eFiExc ; }
    unsigned eFiArm(int i) const { return _mpeFiArm[i]; }
    void eFiArm( int i, unsigned __eFiArm) { _mpeFiArm[i]=__eFiArm ; }
    unsigned eFiEna(int i) const { return _mpeFiEna[i]; }
    void eFiEna( int i, unsigned __eFiEna) { _mpeFiEna[i]=__eFiEna ; }

    TinaConfig(int e=0x7, size_t s=0);
    ~TinaConfig() {}
  };


  /*
   * class TinaSample - start sampling
   */

  class TinaSample:public UmiControl  {
    UmiTime _tiTmo;
    unsigned _cFifo;	/* fifo count	*/
    unsigned _mpiFifo[2];	/* fifo numbers	*/
    unsigned _cMax;	/* max count	*/
   public:
     friend xistream& xunmarsh(xistream &xi, TinaSample&);
     friend xostream& xmarshal(xostream &xo, const TinaSample&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const TinaSample&);
    #endif
    const UmiTime& tiTmo() const { return _tiTmo; }
    void tiTmo( const UmiTime& __tiTmo) {_tiTmo=__tiTmo ; }
    unsigned cFifo() const { return _cFifo; }
    TinaSample& cFifo(unsigned __cFifo) { _cFifo=__cFifo ; return *this; }
    unsigned iFifo(int i) const { return _mpiFifo[i]; }
    void iFifo( int i, unsigned __iFifo) { _mpiFifo[i]=__iFifo ; }
    unsigned cMax() const { return _cMax; }
    TinaSample& cMax(unsigned __cMax) { _cMax=__cMax ; return *this; }

    TinaSample(int e=0x8, size_t s=0);
    ~TinaSample() {}
  };


  /*
   * class TinaStop - stop sampling
   */

  class TinaStop:public UmiControl  {
   public:
     friend xistream& xunmarsh(xistream &xi, TinaStop&);
     friend xostream& xmarshal(xostream &xo, const TinaStop&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const TinaStop&);
    #endif

    TinaStop(int e=0x9, size_t s=0);
    ~TinaStop() {}
  };


  /*
   * class TinaResp - status response
   */

  class TinaResp:public UmiControl  {
    unsigned _eErr;	/* result (error) code	*/
    unsigned _iErr;	/* result (error) code, detailed	*/
   public:
     friend xistream& xunmarsh(xistream &xi, TinaResp&);
     friend xostream& xmarshal(xostream &xo, const TinaResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const TinaResp&);
    #endif
    unsigned eErr() const { return _eErr; }
    TinaResp& eErr(unsigned __eErr) { _eErr=__eErr ; return *this; }
    unsigned iErr() const { return _iErr; }
    TinaResp& iErr(unsigned __iErr) { _iErr=__iErr ; return *this; }

    TinaResp(int e=0xa, size_t s=0);
    ~TinaResp() {}
  };


  /*
   * class TinaSampleResp - sample response
   */

  class TinaSampleResp:public TinaResp  {
    unsigned _cSamples;	/* sample count	*/
    unsigned _iFifo;	/* fifo number	*/
   public:
     friend xistream& xunmarsh(xistream &xi, TinaSampleResp&);
     friend xostream& xmarshal(xostream &xo, const TinaSampleResp&);
    #ifndef _MM_NO_IOSTREAM
     friend std::ostream& operator<<(std::ostream &os, const TinaSampleResp&);
    #endif
    unsigned cSamples() const { return _cSamples; }
    TinaSampleResp& cSamples(unsigned __cSamples) { _cSamples=__cSamples ; return *this; }
    unsigned iFifo() const { return _iFifo; }
    TinaSampleResp& iFifo(unsigned __iFifo) { _iFifo=__iFifo ; return *this; }

    TinaSampleResp(int e=0xb, size_t s=0);
    ~TinaSampleResp() {}
  };

  inline bool isTinaPulseConfig(const UmiControl *puc) { return ( puc->eType() == 0x4 ); }
  extern TinaPulseConfig* pTinaPulseConfig(UmiControl *);
  inline const TinaPulseConfig* pTinaPulseConfig(const UmiControl *puc) { return pTinaPulseConfig(const_cast<UmiControl*>(puc)); }
  inline bool isTinaSetTimer(const UmiControl *puc) { return ( puc->eType() == 0x5 ); }
  extern TinaSetTimer* pTinaSetTimer(UmiControl *);
  inline const TinaSetTimer* pTinaSetTimer(const UmiControl *puc) { return pTinaSetTimer(const_cast<UmiControl*>(puc)); }
  inline bool isTinaInit(const UmiControl *puc) { return ( puc->eType() == 0x6 ); }
  extern TinaInit* pTinaInit(UmiControl *);
  inline const TinaInit* pTinaInit(const UmiControl *puc) { return pTinaInit(const_cast<UmiControl*>(puc)); }
  inline bool isTinaConfig(const UmiControl *puc) { return ( puc->eType() == 0x7 ); }
  extern TinaConfig* pTinaConfig(UmiControl *);
  inline const TinaConfig* pTinaConfig(const UmiControl *puc) { return pTinaConfig(const_cast<UmiControl*>(puc)); }
  inline bool isTinaSample(const UmiControl *puc) { return ( puc->eType() == 0x8 ); }
  extern TinaSample* pTinaSample(UmiControl *);
  inline const TinaSample* pTinaSample(const UmiControl *puc) { return pTinaSample(const_cast<UmiControl*>(puc)); }
  inline bool isTinaStop(const UmiControl *puc) { return ( puc->eType() == 0x9 ); }
  extern TinaStop* pTinaStop(UmiControl *);
  inline const TinaStop* pTinaStop(const UmiControl *puc) { return pTinaStop(const_cast<UmiControl*>(puc)); }
  inline bool isTinaResp(const UmiControl *puc) { return ( puc->eType() == 0xa ); }
  extern TinaResp* pTinaResp(UmiControl *);
  inline const TinaResp* pTinaResp(const UmiControl *puc) { return pTinaResp(const_cast<UmiControl*>(puc)); }
  inline bool isTinaSampleResp(const UmiControl *puc) { return ( puc->eType() == 0xb ); }
  extern TinaSampleResp* pTinaSampleResp(UmiControl *);
  inline const TinaSampleResp* pTinaSampleResp(const UmiControl *puc) { return pTinaSampleResp(const_cast<UmiControl*>(puc)); }

  #define MSG_TinaPulseConfig 0x4
  #define MSG_TinaSetTimer 0x5
  #define MSG_TinaInit 0x6
  #define MSG_TinaConfig 0x7
  #define MSG_TinaSample 0x8
  #define MSG_TinaStop 0x9
  #define MSG_TinaResp 0xa
  #define MSG_TinaSampleResp 0xb

  class Tina_tina_Proto:public UmiProto {
   public:
    xistream& unmarsh(xistream &, const UmiControl &, UmiControl *) const;
    xostream& marshal(xostream &, const UmiControl *) const ;
    Tina_tina_Proto();
    ~Tina_tina_Proto();
  };

  #define PROTID_tina "(/Int4:unsigned,Int4:unsigned/)(//(/Int4:u_int,Int4:u_int/))(//)(/Int2:unsigned,Int2:unsigned,Int2:unsigned/(/Int4:u_int,Int4:u_int/))(//)(/Int4:unsigned,Int1:unsigned,Int2:unsigned,Int2:unsigned,Int1:unsigned,Int1:unsigned,Int1:unsigned,Int1:unsigned,Int1:unsigned,Int1:unsigned,Int1:unsigned,Int1:unsigned/)(//)((/Int4:unsigned,Int4:unsigned/)/Int2:unsigned,Int2:unsigned/)"
  /* Services */
  /* SetTimer */
  class Tina_tina_Service_SetTimer:public UmiService {
    TinaSetTimer _rq;
    TinaResp _rp;
  };
  /* Init */
  class Tina_tina_Service_Init:public UmiService {
    TinaInit _rq;
    TinaResp _rp;
  };
}
#endif
