#ifndef _UMI_UCK_HXX
#define _UMI_UCK_HXX

/**
 * \file 
 * Device Call Umi Channel
 */

#include <assert.h>
#if (defined(MMSYS_win) || defined(MMSYS_mingw))
  #include <windows.h>
#endif
#if (defined(MMSYS_linux) || defined(MMSYS_qnx))
  //#include <pthread.h> 
  #include <poll.h>
#endif
#include "umic/umi_driver.hxx"
#include "umi/umi_user.hxx"
#include "cplRaw/failable.hxx"

#define DO_POLL (0)


namespace INdepUmi100 {


  /**
   * Device Call Umi Channel
   */
  class UmiChanDevio : public UmiChanUser {

    #if (defined(MMSYS_linux) || defined(MMSYS_qnx))
      int _fd;			/* local fd */
     #if DO_POLL
      struct pollfd _mpfd[1];
     #endif
    #else
      HANDLE _h;			
    #endif

   public:

    #if (defined(MMSYS_linux) || defined(MMSYS_qnx))
      int fd() { return _fd; }
    #endif

    /**
     * \name Network side arming
     *
     * These functions are called when buffers are set up to send or receive.
     * 
     */
    //@{
    virtual void armSend();
    virtual void armRecv();	
    //@}

    Failables &sigSendTransfer();
    Failables &sigRecvTransfer();


    /** create */
    UmiChanDevio(const UmiProto *pup, const char *szDev, const char *szChan);
    ~UmiChanDevio();
  };

  typedef UmiChanDevio ChanDevio;

}

#endif
