#!/bin/sh
#
# udev RUN script for ines "itina" device class
#
# environment variables:
#  SUBSYSTEM the Umi controlled device class
#  MINOR device instance (kernel slot)
#
# /dev path layout:
#  /dev/<subsystem>/<instance>/<driver>/<channel>



INSTANCE=${1:-$MINOR}
DIR=/dev/$SUBSYSTEM/$INSTANCE

# adjust minor number
CARD=$(($MINOR<<4))

case "$ACTION" in
    add)

      mkdir -p $DIR/sio
      mkdir -p $DIR/aes
      mknod $DIR/sio/0 c $MAJOR $(($CARD+0))
      mknod $DIR/aes/0 c $MAJOR $(($CARD+0))
      chmod 0666 $DIR/*/*
    ;;
    remove)
      rm -r $DIR
    ;;
esac


